/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view;

import junit.framework.TestCase;

/**
 * Unit test cases for RendererException.
 *
 * @author TCSDeveloper
 */
public class RendererExceptionUnitTests extends TestCase {

    /**
     * The message to use.
     */
    private String message = "renderer fails";

    /**
     * The inner exception.
     */
    private Exception cause = new Exception();

    /**
     * Create instance with message.
     */
    public void testCreate_Message() {
        RendererException re = new RendererException(message);
        assertTrue("Message mismatches.", re.getMessage().indexOf(message) != -1);
    }

    /**
     * Create instance with null message.
     */
    public void testCreate_NullMessage() {
        try {
            new RendererException(null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) {
        }
    }

    /**
     * Create instance with empty message.
     */
    public void testCreate_EmptyMessage() {
        try {
            new RendererException(" ");
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException iae) {
        }
    }

    /**
     * Create instance with message and cause.
     */
    public void testCreate_MessageCause() {
        RendererException re = new RendererException(message, cause);
        assertTrue("Message mismatches.", re.getMessage().indexOf(message) != -1);
        assertEquals("Cause mismatches.", cause, re.getCause());
    }

    /**
     * Create instance with null message.
     */
    public void testCreate_NullMessage2() {
        try {
            new RendererException(null, cause);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) {
        }
    }

    /**
     * Create instance with empty message.
     */
    public void testCreate_EmptyMessage2() {
        try {
            new RendererException(" ", cause);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException iae) {
        }
    }

    /**
     * Create instance with null cause.
     */
    public void testCreate_NullCause() {
        try {
            new RendererException(message, null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) {
        }
    }

}
