/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.failuretests;

import java.awt.geom.GeneralPath;

import junit.framework.TestCase;

import com.topcoder.rules.dependencymap.view.ShapeFactory;

/**
 * Failure test cases for FixedGridLayoutManager.
 *
 * @author AdamSelene
 */
public class ShapeFactoryTest extends TestCase {
    
	private GeneralPath goodShape = new GeneralPath();
	
	/**
     * Invalid input to set.
     *
     */
	public void testSet_Inv() {
        try {
            new ShapeFactory().setShape(-1, goodShape);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }

	/**
     * Invalid input to set.
     *
     */
	public void testSet_Inv2() {
        try {
            new ShapeFactory().setShape(Integer.MIN_VALUE, goodShape);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }

	/**
     * Invalid input to set.
     *
     */
	public void testSet_Inv3() {
        try {
            new ShapeFactory().setShape(0, goodShape);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to set.
     *
     */
	public void testSet_Null() {
        try {
            new ShapeFactory().setShape(1, null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

	/**
     * Invalid input to Get.
     *
     */
	public void testGet_Inv() {
        try {
            new ShapeFactory().getShape(-1);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testGet_Inv2() {
        try {
            new ShapeFactory().getShape(Integer.MIN_VALUE);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testGet_Inv3() {
        try {
            new ShapeFactory().getShape(0);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testRemove_Inv() {
        try {
            new ShapeFactory().removeShape(-1);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testRemove_Inv2() {
        try {
            new ShapeFactory().removeShape(Integer.MIN_VALUE);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testRemove_Inv3() {
        try {
            new ShapeFactory().removeShape(0);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testRemove_InvPD() {
        try {
            new ShapeFactory().removeShape(ShapeFactory.RELATIONSHIP_ARROW);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testRemove_InvPD2() {
        try {
            new ShapeFactory().removeShape(ShapeFactory.SEEN_ELEMENT);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
	
	/**
     * Invalid input to Get.
     *
     */
	public void testRemove_InvPD3() {
        try {
            new ShapeFactory().removeShape(ShapeFactory.UNSEEN_ELEMENT);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }
}
